#line 1 "C:/Users/System Administrator/Desktop/mikroC PRO for PIC/Working/Clock/Libstock ver2/I2C 16x2, 20x2, 20x4 LCD PIC mC/I2C LCD.c"
#line 22 "C:/Users/System Administrator/Desktop/mikroC PRO for PIC/Working/Clock/Libstock ver2/I2C 16x2, 20x2, 20x4 LCD PIC mC/I2C LCD.c"
char txt1[] = "I2C LCD";
char txt2[] = "16x2, 20x2, 20x4";
char txt3[] = "PIC12F1840";
char txt4[] = "4 MHz";

void I2C_LCD_Cmd(char out_char) {

 char byte;

 byte = out_char & 0xF0;

 I2C1_Start();
 I2C1_Is_Idle();
 I2C1_Wr( 0x4E );
 I2C1_Is_Idle();

 byte.F0 = 0;
 byte.F2 = 1;
 byte.F3 = 1;
 I2C1_Wr(byte);
 I2C1_Is_Idle();
 byte.F2 = 0;
 I2C1_Wr(byte);
 I2C1_Is_Idle();

 byte = (out_char << 4) & 0xF0;

 byte.F0 = 0;
 byte.F2 = 1;
 byte.F3 = 1;
 I2C1_Wr(byte);
 I2C1_Is_Idle();
 byte.F2 = 0;
 I2C1_Wr(byte);
 I2C1_Is_Idle();
 I2C1_stop();

 if(out_char == 0x01)Delay_ms(2);
}

void I2C_LCD_Chr(char row, char column, char out_char) {

 char byte;

 switch(row){

 case 1:
 I2C_LCD_Cmd(0x80 + (column - 1));
 break;
 case 2:
 I2C_LCD_Cmd(0xC0 + (column - 1));
 break;
 case 3:
 I2C_LCD_Cmd(0x94 + (column - 1));
 break;
 case 4:
 I2C_LCD_Cmd(0xD4 + (column - 1));
 break;
 };

 byte = out_char & 0xF0;

 I2C1_Start();
 I2C1_Is_Idle();
 I2C1_Wr( 0x4E );
 I2C1_Is_Idle();

 byte.F0 = 1;
 byte.F2 = 1;
 byte.F3 = 1;
 I2C1_Wr(byte);
 I2C1_Is_Idle();
 byte.F2 = 0;
 I2C1_Wr(byte);
 I2C1_Is_Idle();

 byte = (out_char << 4) & 0xF0;

 byte.F0 = 1;
 byte.F2 = 1;
 byte.F3 = 1;
 I2C1_Wr(byte);
 I2C1_Is_Idle();
 byte.F2 = 0;
 I2C1_Wr(byte);
 I2C1_Is_Idle();

 I2C1_stop();
}

void I2C_LCD_Chr_Cp(char out_char) {

 char byte;

 byte = out_char & 0xF0;

 I2C1_Start();
 I2C1_Is_Idle();
 I2C1_Wr( 0x4E );
 I2C1_Is_Idle();

 byte.F0 = 1;
 byte.F2 = 1;
 byte.F3 = 1;
 I2C1_Wr(byte);
 I2C1_Is_Idle();
 byte.F2 = 0;
 I2C1_Wr(byte);
 I2C1_Is_Idle();

 byte = (out_char << 4) & 0xF0;

 byte.F0 = 1;
 byte.F2 = 1;
 byte.F3 = 1;
 I2C1_Wr(byte);
 I2C1_Is_Idle();
 byte.F2 = 0;
 I2C1_Wr(byte);
 I2C1_Is_Idle();

 I2C1_stop();
}


void I2C_LCD_Init() {

 char byte;

 Delay_ms(150);

 I2C1_Start();
 I2C1_Is_Idle();
 I2C1_Wr( 0x4E );
 I2C1_Is_Idle();

 Delay_ms(30);

 byte = 0x30;
 byte.F3 = 1;

 byte.F2 = 1;
 I2C1_Wr(byte);
 I2C1_Is_Idle();
 byte.F2 = 0;
 I2C1_Wr(byte);
 I2C1_Is_Idle();

 Delay_ms(30);

 byte.F2 = 1;
 I2C1_Wr(byte);
 I2C1_Is_Idle();
 byte.F2 = 0;
 I2C1_Wr(byte);
 I2C1_Is_Idle();

 Delay_ms(30);

 byte.F2 = 1;
 I2C1_Wr(byte);
 I2C1_Is_Idle();
 byte.F2 = 0;
 I2C1_Wr(byte);
 I2C1_Is_Idle();

 Delay_ms(20);

 byte = 0x20;
 byte.F3 = 1;

 byte.F2 = 1;
 I2C1_Wr(byte);
 I2C1_Is_Idle();
 byte.F2 = 0;
 I2C1_Wr(byte);
 I2C1_Is_Idle();

 Delay_ms(10);

 I2C_LCD_Cmd(0x28);
 I2C_LCD_Cmd(0x06);
}

void I2C_LCD_Out(char row, char col, char *text) {
 while(*text)
 I2C_LCD_Chr(row, col++, *text++);
}

void I2C_LCD_Out_Cp(char *text) {
 while(*text)
 I2C_LCD_Chr_Cp(*text++);
}

void main() {

 ANSELA = 0x00;
 TRISA = 0x00;
 PORTA = 0x00;
 LATA = 0x00;

 I2C1_Init(100000);
 Delay_ms(200);

 I2C_LCD_Init();
 I2C_LCD_Cmd( 0x0C );
 I2C_LCD_Cmd( 0x01 );

 while(1) {

 I2C_Lcd_Out(1,1,txt1);
 I2C_Lcd_Out(2,1,txt2);
 I2C_Lcd_Out(3,1,txt3);
 I2C_Lcd_Out(4,1,txt4);
 Delay_ms(2000);

 }
}
